#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 RoyalBlue
#property indicator_width1 5

int int1 = 2;
extern int StartAtCycle = 1;
extern int UseTopCycles = 2;
extern int UseCycleList = 0;
extern int Cycle1 = 1;
extern int Cycle2 = 1;
extern int Cycle3 = 1;
extern int Cycle4 = 1;
extern int Cycle5 = 1;
extern int MaxPer = 120;
extern int numbars = 1000;
extern int bar2update = 1;

extern int SubtractNoise = 0;
extern int Offset = 0;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[][20];
double buffer6[];
int int1_time = 0;
int int2 = 4;
string string1 = "";
double pi = 3.1415926535;
int number_of_cycles = 0;
double cyclebuffer[301];
double amplitudebuffer[301];
double phasebuffer[301];
double double4[];

double GetValue( int bar )
{
  return( Close[ bar ] );
}

int init() {
   if (int1 < 2) int1 = 2;
   if (MaxPer < int1)  MaxPer = int1;
   if (bar2update < 0) bar2update = 1;
   IndicatorDigits(int2);
   IndicatorBuffers(5);
   SetIndexBuffer(0, double4);
   SetIndexBuffer(1, buffer1);
   SetIndexBuffer(2, buffer2);
   SetIndexBuffer(3, buffer3);
   SetIndexBuffer(4, buffer4);
   SetIndexEmptyValue(0, 0.0);
   SetIndexEmptyValue(1, 0.0);
   SetIndexEmptyValue(2, 0.0);
   SetIndexEmptyValue(3, 0.0);
   SetIndexEmptyValue(4, 0.0);
   return (0);
}

int deinit() {
   Comment(" ");
   return (0);
}

int start() {
   string string2;
   string string3;
   double u;
   double w;
   double x;
   int counted_bars = IndicatorCounted();
//   int counted_bars = 0;
   string1 = "";
   if (Bars < 3 * MaxPer) {
      Print(" Not Enough bars: you need 3*MaxPer -> " + DoubleToStr(3 * MaxPer, 0));
      return (0);
   }
   if (ArrayRange(buffer5,0)!=Bars) ArrayResize(buffer5,Bars);
      ArrayInitialize(cyclebuffer,0);
      ArrayInitialize(amplitudebuffer,0);
      ArrayInitialize(phasebuffer,0);
   
   //
   //
   //
   //
   //
   
   if (bar2update < 1) bar2update = 1;
      string2 = "";
      string3 = "";
      int1_time = Time[0];
      ComputeIt(1);
      number_of_cycles = 0;
      for (int barr = 0; barr < MaxPer + 2; barr++)
      {
         if (buffer3[barr] > 0.0)
         {
            number_of_cycles++;
               cyclebuffer[number_of_cycles]     = MathRound(10000.0 * buffer3[barr]);
               amplitudebuffer[number_of_cycles] = buffer1[barr];
               phasebuffer[number_of_cycles]     = buffer2[barr];
         }
      }
      for (barr = 1; barr < number_of_cycles; barr++) {
         for (int barrr = barr + 1; barrr < number_of_cycles + 1; barrr++) {
            if (amplitudebuffer[barrr] > amplitudebuffer[barr])
            {
               u = amplitudebuffer[barr];
               w = cyclebuffer[barr];
               x = phasebuffer[barr];
               amplitudebuffer[barr] = amplitudebuffer[barrr];
               cyclebuffer[barr]     = cyclebuffer[barrr];
               phasebuffer[barr]     = phasebuffer[barrr];
               amplitudebuffer[barrr] = u;
               cyclebuffer[barrr] = w;
               phasebuffer[barrr] = x;
            }
         }
      }
      for (barr = 1; barr < number_of_cycles + 1; barr++) {
         string3 = StringConcatenate("Period = ", cyclebuffer[barr], "   Amplitude = ", DoubleToStr(amplitudebuffer[barr], 4), "    Phase = ", DoubleToStr(phasebuffer[barr], 4), 
         "\n");
         string2 = StringConcatenate(string2, string3);
      }
      Comment(StringConcatenate("\n" + "There are ", number_of_cycles, " cycles in the current frame.", "\n", "\n", string2));
      calcwaves();
      for (barrr = 0; barrr < numbars; barrr++) {
         if (UseCycleList == 1) {
            if (Cycle1 > 0) double4[barrr] += buffer5[Bars-barrr-1][Cycle1];
            if (Cycle2 > 0) double4[barrr] += buffer5[Bars-barrr-1][Cycle2];
            if (Cycle3 > 0) double4[barrr] += buffer5[Bars-barrr-1][Cycle3];
            if (Cycle4 > 0) double4[barrr] += buffer5[Bars-barrr-1][Cycle4];
            if (Cycle5 > 0) double4[barrr] += buffer5[Bars-barrr-1][Cycle5];
         }
         else
         {
            double4[barrr] = 0;
            for (barr = StartAtCycle; barr < StartAtCycle + UseTopCycles; barr++) double4[barrr] += buffer5[Bars-barrr-1][barr];
            if (SubtractNoise == 1) for (barr = StartAtCycle + UseTopCycles; barr < number_of_cycles + 1; barr++) double4[barrr] = double4[barrr] - buffer5[Bars-barrr-1][barr];
         }
      }
   return (0);
}

int calcwaves() {
   int cycle;
   double amplitude;
   double phase;
   int j;
   double u;
   double w;
   double x;
   double y;
   double z;
   for (int i = 1; i < number_of_cycles + 1; i++)
   {
      cycle     = cyclebuffer[i];
      amplitude = amplitudebuffer[i];
      phase     = phasebuffer[i];
      j = MaxPer;
      u = 2.0 * pi / cycle;
      w = cycle;
      x = amplitude;
      y = phase;

//////////////////////////////////////
//COMPOSITE WAVE:      
//////////////////////////////////////
                                    //
      z = y * (180 / pi) / 360.0;   //
                                    //
//////////////////////////////////////

      while (j < numbars) {
         buffer5[Bars-(j- MaxPer)-1][i] = x * MathSin(u * (j + Offset + cycle / 2 + z * w));
         j++;
      }
   }
   return (0);
}

int ComputeIt(int val5) {
   double w;
   double x;
   double y;
   double z;
   double val1;
   double val2;
   double val3;
   for (int k = 0; k <= MaxPer + 3; k++) {
      buffer1[k] = 0;
      buffer2[k] = 0;
      buffer3[k] = 0.0;
   }
   for (k = 0; k <= 3 * MaxPer + 3; k++) buffer4[k] = 0;
   double val4 = GetValue(val5 + 3 * MaxPer - 1);
   double u = (GetValue(val5) - val4) / (val5 + 3 * MaxPer - 2);
   for (k = 3 * MaxPer; k >= 1; k--) buffer4[k] = GetValue(val5 + k - 1) - (val4 + u * (3 * MaxPer - k));
   for (k = int1; k <= MaxPer; k++) {
      w = 0;
      x = 0;
      y = 0;
      z = MathPow(k, -1);
      val1 = 2.0 * MathCos(2.0 * pi * z);
      for (int val6 = 3 * MaxPer; val6 >= 1; val6--) {
         w = val1 * x - y + buffer4[val6];
         y = x;
         x = w;
      }
      val2 = x - y / 2.0 * val1;
      val3 = y * MathSin(2.0 * pi * z);
      buffer1[k] = MathPow(val2, 2) + MathPow(val3, 2);
      if (val2 != 0.0) buffer2[k] = MathArctan(val3 / val2);
      else {
         val2 = 0.0000001;
         buffer2[k] = MathArctan(val3 / val2);
      }
      if (val2 < 0.0) buffer2[k] += pi;
      else
         if (val2 >= 0.0 && val3 < 0.0) buffer2[k] += 2.0 * pi;
   }
   for (k = int1 + 1; k < MaxPer; k++) {
      if (buffer1[k] > buffer1[k + 1] && buffer1[k] > buffer1[k - 1]) buffer3[k] = k * MathPow(10, -1 * int2);
      else buffer3[k] = 0.0;
   }
   return (0);
}


